<?php
defined('_JEXEC') or die;

class PerfectDashboard_Cms_Joomla_Request extends PerfectDashboard_Request
{
	/**
	 * @return JHttp
	 */
	protected function getHttp()
	{
		$ssl_verify = (bool) PerfectDashboard_Config::get('ssl_verify', false);

		$options = PerfectDashboard_Cms_Joomla_Helper_Joomla::getRegistry(array(
			'verify_peer' => $ssl_verify
		));

		if (defined('CURLOPT_SSL_VERIFYPEER'))
		{
			$options->set('transport.curl', array(CURLOPT_SSL_VERIFYPEER => $ssl_verify));
		}

		return JHttpFactory::getHttp($options);
	}

	protected function makeGetRequest($url, $data = null, $headers = null, $timeout = null)
	{
		if (is_array($data))
		{
			$query = array();
			foreach ($data as $key => $value)
			{
				$query[] = $key . '=' . urlencode($value);
			}

			if (!empty($query))
			{
				$url .= (strpos($url, '?') === false ? '?' : '&') . implode('&', $query);
			}
		}

		try
		{
			PerfectDashboard_Log::debug("GET $url");
			$result = $this->getHttp()->get($url, $headers, $timeout ? $timeout : static::$timeout);
		}
		catch (Exception $e)
		{
			$result = $e;
		}

		return PerfectDashboard_Response::getInstance()
			->bind($result);
	}

	protected function makePostRequest($url, $data = null, $headers = null, $timeout = null)
	{
		if (!empty($data))
		{
			if (isset($headers['Content-Type']) &&
				strpos($headers['Content-Type'], 'application/json') !== false &&
				!is_scalar($data))
			{
				$data = json_encode($data);
			}
		}

		try
		{
			PerfectDashboard_Log::debug("POST $url\nData " . (is_scalar($data) ? $data : print_r($data, true)));
			$result = $this->getHttp()->post($url, $data, $headers, $timeout ? $timeout : static::$timeout);
		}
		catch (Exception $e)
		{
			$result = $e;
		}

		return PerfectDashboard_Response::getInstance()
			->bind($result);
	}
}