<?php
defined('PERFECTDASHBOARD_LIB') or die;

class PerfectDashboard_Exception_Response extends Exception
{
	/**
	 * @var int
	 */
	protected $error_code = 0;
	/**
	 * @var string
	 */
	protected $error_message = '';

	/**
	 * PerfectDashboard_Exception_Response constructor.
	 *
	 * @param string         $message JSON message
	 * @param int            $code    HTTP code
	 * @param null|Exception $previous
	 */
	public function __construct($message = '', $code = 0, $previous = null)
	{
		parent::__construct($message, $code, $previous);
	}

	/**
	 * @param int    $code
	 * @param string $message
	 */
	public function setError($code, $message)
	{
		$this->error_code    = (int) $code;
		$this->error_message = $message;
	}

	/**
	 * @return int
	 */
	public function getErrorCode()
	{
		return $this->error_code;
	}

	/**
	 * @return string
	 */
	public function getErrorMessage()
	{
		return $this->error_message;
	}
}