<?php
defined('PERFECTDASHBOARD_LIB') or die;

class PerfectDashboard_Task_PostFileDownload extends PerfectDashboard_Task_Base
{
	/**
	 * @throws PerfectDashboard_Exception_Response
	 *
	 * @return array
	 */
	public function doTask()
	{
		$url = $this->input('file_url');
		if (!$url)
		{
			throw new PerfectDashboard_Exception_Response('Nothing to download', 400);
		}

		try
		{
			$path = PerfectDashboard_Filemanager::getInstance()
				->download($url);
		}
		catch (Exception $e)
		{
			return array(
				'success' => false,
				'error'   => array(
					'code'    => $e->getCode(),
					'message' => $e->getMessage(),
				),
			);
		}

		return array(
			'success' => $path ? true : false,
			'return'  => array(
				'file_path' => str_replace(PERFECTDASHBOARD_SITE_PATH, '', $path),
			),
		);
	}
}