<?php
defined('PERFECTDASHBOARD_LIB') or die;

class PerfectDashboard_Task_PostFileUnpack extends PerfectDashboard_Task_Base
{
	/**
	 * @throws PerfectDashboard_Exception_Response
	 *
	 * @return array
	 */
	public function doTask()
	{
		$file_path = $this->input('file_path');
		if (empty($file_path))
		{
			throw new PerfectDashboard_Exception_Response('Nothing to unpack', 400);
		}

		$filemanager = PerfectDashboard_Filemanager::getInstance();
		$destination = $this->input('destination');

		if (!$filemanager->is_file($file_path))
		{
			$file_path = PERFECTDASHBOARD_SITE_PATH . $file_path;
			if (!$filemanager->is_file($file_path))
			{
				throw new PerfectDashboard_Exception_Response('Archive not found', 404);
			}
		}

		$result = array(
			'success' => false,
		);

		try
		{
			$destination = $filemanager->unpack($file_path, $destination);
			if ($destination)
			{
				$result['success'] = true;
				$result['return']  = array(
					'path' => $destination,
				);

				$filemanager->clearPhpCache();
			}
		}
		catch (Exception $e)
		{
			$result['error'] = array(
				'code'    => $e->getCode(),
				'message' => $e->getMessage(),
			);
		}

		$filemanager->delete($file_path);

		return $result;
	}
}