<?php
/**
 * @package     perfectdashboard
 * @version     1.12
 *
 * @copyright   Copyright (C) 2017 Perfect Dashboard. All rights reserved. https://perfectdashboard.com
 * @license     GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
 */

defined('_JEXEC') or die;

class PlgSystemPerfectdashboard extends JPlugin
{
	public function onAfterInitialise()
	{
		if (version_compare(PHP_VERSION, '5.3', '<'))
		{
			return;
		}

		$app = JFactory::getApplication();
		if (version_compare(JVERSION, '3.7', '>='))
		{
			$is_admin = $app->isClient('administrator');
		}
		else
		{
			$is_admin = $app->isAdmin();
		}

		// Do not load plugin if Joomla is installing, updating or removing some extension
		if ($is_admin && $app->input->get('option') == 'com_installer' &&
			in_array($app->input->get('task'), array('install.install', 'update.update', 'manage.remove'))
		)
		{
			return;
		}

		require_once dirname(__FILE__) . '/defines.php';
		require_once dirname(__FILE__) . '/lib/src/Init.php';

		$api = PerfectDashboard_Api::getInstance();

		require_once PERFECTDASHBOARD_LIB_PATH . 'Installer.php';
		PerfectDashboard_Installer::getInstance()->selfUpdate();

		$api->handle();
	}
}