<?php

defined('_JEXEC') or die('resticted aceess');

class SppagebuilderAddonHeading extends SppagebuilderAddons {

    public function render() {

        $class = (isset($this->addon->settings->class) && $this->addon->settings->class) ? ' ' . $this->addon->settings->class : '';
        $class .= (isset($this->addon->settings->alignment) && $this->addon->settings->alignment) ? ' ' . $this->addon->settings->alignment : ' sppb-text-center';
        $title = (isset($this->addon->settings->title) && $this->addon->settings->title) ? $this->addon->settings->title : '';
        $heading_selector = (isset($this->addon->settings->heading_selector) && $this->addon->settings->heading_selector) ? $this->addon->settings->heading_selector : 'h2';
        $use_link = (isset($this->addon->settings->use_link) && $this->addon->settings->use_link) ? $this->addon->settings->use_link : false;
        $title_link = ($use_link) ? ((isset($this->addon->settings->title_link) && $this->addon->settings->title_link) ? $this->addon->settings->title_link : '') : false;
        $link_target = (isset($this->addon->settings->link_new_tab) && $this->addon->settings->link_new_tab) ? 'target="_blank"' : '';
        $heading_style = (isset($this->addon->settings->heading_style) && $this->addon->settings->heading_style) ? $this->addon->settings->heading_style : '';
        $subtitle = (isset($this->addon->settings->subtitle) && $this->addon->settings->subtitle) ? $this->addon->settings->subtitle : '';

        $output = '';
        if ($title) {
            $output .= '<div class="sppb-addon sppb-addon-heading sppb-addon-heading-' . $heading_style . ' ' . $class . '">';

            $output .= '<' . $heading_selector . ' class="sppb-heading-title">' . nl2br($title) . '</' . $heading_selector . '>';
            if ($subtitle) {
                $output .= '<p class="sppb-lead sppb-headling-subtitle">' . $subtitle . '</p>';
            }
            $output .= '</div>';
        }

        return $output;
    }

    public function css() {
        $addon_id = '#sppb-addon-' . $this->addon->id;

        $style = (isset($this->addon->settings->title_lineheight) && $this->addon->settings->title_lineheight) ? "line-height: " . $this->addon->settings->title_lineheight . ";" : "";
        $style .= (isset($this->addon->settings->title_letterspace) && $this->addon->settings->title_letterspace) ? 'letter-spacing: ' . $this->addon->settings->title_letterspace . ';' : '';
        $style .= (isset($this->addon->settings->title_fontsize) && $this->addon->settings->title_fontsize) ? 'font-size: ' . $this->addon->settings->title_fontsize . 'px; ' : '';
        $style .= (isset($this->addon->settings->title_margin) && $this->addon->settings->title_margin) ? 'margin: ' . $this->addon->settings->title_margin . 'px; ' : '';
        $style .= (isset($this->addon->settings->title_padding) && $this->addon->settings->title_padding) ? 'padding: ' . $this->addon->settings->title_padding . '; ' : '';
        $font_style = (isset($this->addon->settings->title_fontstyle) && $this->addon->settings->title_fontstyle) ? $this->addon->settings->title_fontstyle : '';

        if (is_array($font_style) && count($font_style)) {
            if (in_array('underline', $font_style)) {
                $style .= 'text-decoration: underline;';
            }

            if (in_array('uppercase', $font_style)) {
                $style .= 'text-transform: uppercase;';
            }

            if (in_array('italic', $font_style)) {
                $style .= 'font-style: italic;';
            }

            if (in_array('lighter', $font_style)) {
                $style .= 'font-weight: lighter;';
            } else if (in_array('normal', $font_style)) {
                $style .= 'font-weight: normal;';
            } else if (in_array('bold', $font_style)) {
                $style .= 'font-weight: bold;';
            } else if (in_array('bolder', $font_style)) {
                $style .= 'font-weight: bolder;';
            }
        }

        $heading_selector = (isset($this->addon->settings->heading_selector) && $this->addon->settings->heading_selector) ? $this->addon->settings->heading_selector : 'h2';

        $css = '';
        if ($style) {
            $css .= $addon_id . ' ' . $heading_selector . '.sppb-heading-title {' . $style . '}';
        }

        $subtitle_style = (isset($this->addon->settings->subtitle_text_color) && $this->addon->settings->subtitle_text_color) ? 'color: ' . $this->addon->settings->subtitle_text_color . '; ' : '';
        $subtitle_style .= (isset($this->addon->settings->subtitle_fontsize) && $this->addon->settings->subtitle_fontsize) ? 'font-size: ' . $this->addon->settings->subtitle_fontsize . 'px; ' : '';
        $subtitle_style .= (isset($this->addon->settings->subtitle_fontweight) && $this->addon->settings->subtitle_fontweight) ? 'font-weight: ' . $this->addon->settings->subtitle_fontweight . '; ' : '';

        if ($subtitle_style) {
            $css .= $addon_id . ' .sppb-headling-subtitle {' . $subtitle_style . '}';
        }

        return $css;
    }

}
